"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = __importStar(require("path"));
var ts = __importStar(require("typescript"));
var git_helpers_1 = require("./git-helpers");
/**
 * Run Typescript compiler on the given project and post results to Github Checks API.
 */
function typescriptCheck(tsConfigFile, checkOptions) {
    return __awaiter(this, void 0, void 0, function () {
        var baseDir, check, compileResult, summary, updateCount, batch, update;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    baseDir = git_helpers_1.getGitRepositoryDirectoryForFile(tsConfigFile);
                    if (!checkOptions) return [3 /*break*/, 2];
                    return [4 /*yield*/, checkOptions.github.checks.create({
                            owner: checkOptions.owner,
                            repo: checkOptions.repo,
                            head_sha: git_helpers_1.getGitSHA(baseDir),
                            name: "Typescript",
                            status: "in_progress"
                        })];
                case 1:
                    check = _a.sent();
                    console.log("Created check " + check.data.id + " (" + check.data.url + ")");
                    _a.label = 2;
                case 2:
                    compileResult = getDiagnosticsForProject(tsConfigFile);
                    compileResult.annotations = compileResult.annotations.map(function (a) { return (__assign(__assign({}, a), { path: path.relative(baseDir, a.path) // patch file paths to be relative to git root
                     })); });
                    summary = compileResult.globalErrors.length +
                        compileResult.annotations.length + " errors.\n\n" +
                        compileResult.globalErrors.join("\n");
                    console.log("Typescript: " + summary);
                    console.log(compileResult.consoleOutput);
                    if (!(checkOptions && check)) return [3 /*break*/, 6];
                    updateCount = 0;
                    _a.label = 3;
                case 3:
                    if (!(updateCount === 0 || compileResult.annotations.length > 0)) return [3 /*break*/, 6];
                    batch = compileResult.annotations.splice(0, 50);
                    return [4 /*yield*/, checkOptions.github.checks.update({
                            check_run_id: check.data.id,
                            owner: checkOptions.owner,
                            repo: checkOptions.repo,
                            output: {
                                annotations: batch,
                                summary: summary,
                                title: "Typescript"
                            },
                            conclusion: compileResult.hasFailures ? "failure" : "success"
                        })];
                case 4:
                    update = _a.sent();
                    console.log("Updated check " + update.data.id + " with " + batch.length + " annotations.");
                    _a.label = 5;
                case 5:
                    updateCount++;
                    return [3 /*break*/, 3];
                case 6: return [2 /*return*/];
            }
        });
    });
}
exports.typescriptCheck = typescriptCheck;
/**
 * Get all Typescript compiler diagnostics for the given TS project.
 */
function getDiagnosticsForProject(configFileName) {
    var diagnosticHost = {
        getCurrentDirectory: ts.sys.getCurrentDirectory,
        getNewLine: function () { return ts.sys.newLine; },
        getCanonicalFileName: function (s) { return s; }
    };
    var parsedCommandLine = ts.getParsedCommandLineOfConfigFile(configFileName, {}, __assign(__assign({}, ts.sys), { onUnRecoverableConfigFileDiagnostic: function (diagnostic) {
            ts.formatDiagnostic(diagnostic, diagnosticHost);
        } }));
    var program = ts.createProgram(parsedCommandLine.fileNames, __assign(__assign({}, parsedCommandLine.options), { noEmit: true }));
    var emitResult = program.emit();
    var allDiagnostics = ts
        .getPreEmitDiagnostics(program)
        .concat(emitResult.diagnostics);
    var annotations = [];
    var globalErrors = [];
    var hasFailures = false;
    for (var _i = 0, allDiagnostics_1 = allDiagnostics; _i < allDiagnostics_1.length; _i++) {
        var diagnostic = allDiagnostics_1[_i];
        if (diagnostic.file) {
            var start = diagnostic.file.getLineAndCharacterOfPosition(diagnostic.start);
            var end = diagnostic.file.getLineAndCharacterOfPosition(diagnostic.start + diagnostic.length);
            annotations.push({
                annotation_level: diagnostic.category === ts.DiagnosticCategory.Error
                    ? "failure"
                    : diagnostic.category === ts.DiagnosticCategory.Warning
                        ? "warning"
                        : "notice",
                start_line: start.line + 1,
                end_line: end.line + 1,
                message: ts.flattenDiagnosticMessageText(diagnostic.messageText, "\n"),
                path: diagnostic.file.fileName
            });
            if (diagnostic.category === ts.DiagnosticCategory.Error) {
                hasFailures = true;
            }
        }
        else if (diagnostic.category === ts.DiagnosticCategory.Error) {
            globalErrors.push(ts.flattenDiagnosticMessageText(diagnostic.messageText, "\n"));
            hasFailures = true;
        }
    }
    var consoleOutput = ts.formatDiagnosticsWithColorAndContext(allDiagnostics, diagnosticHost);
    return { hasFailures: hasFailures, annotations: annotations, globalErrors: globalErrors, consoleOutput: consoleOutput };
}
exports.getDiagnosticsForProject = getDiagnosticsForProject;
